/*
 *check yup150 boot condition
 */

#include <config.h>
#include <version.h>

#include <regs.h>

	.globl check_boot_condition
check_boot_condition:

	/* check yup150 machine configuration */
	ldr     r0, =ELFIN_GPIO_BASE
        ldr     r2, [r0, #GPBCON_OFFSET]
	bic     r1, r2, #((3 << 4)|(3 << 6)|(3 << 8))
	str     r1, [r0, #GPBCON_OFFSET]

	ldr     r2, [r0, #GPBPU_OFFSET]
	bic     r2, r2, #((3 << 4)|(3 << 6)|(3 << 8))
	orr     r1, r2, #((2 << 4)|(2 << 6)|(2 << 8))
	str     r1, [r0, #GPBPU_OFFSET]

99:	ldr     r2, [r0, #GPBDAT_OFFSET]
	and	r1, r2, #((1 << 2)|(1 << 3)|(1 << 4))
	ldr	r2, [r0, #GPBDAT_OFFSET]
	and	r3, r2, #((1 << 2)|(1 << 3)|(1 << 4))
	cmp	r1, r3
	bne	99b

	mov	r4, #((1 << 2)|(1 << 3))
	cmp	r1, r4
	bne     10f

#if 0
	/* print yup150 machine character */
	ldr     r0, =ELFIN_GPIO_BASE
	ldr     r1, =0x33333333
	str     r1, [r0, #UTXH_OFFSET]
#endif

	/* YUP150 external power ON/OFF STATE */	
	ldr     r0, =ELFIN_GPIO_BASE
	ldr     r2, [r0, #GPFCON_OFFSET]
	bic     r1, r2, #(3 << 12)
	str     r1, [r0, #GPFCON_OFFSET]

	ldr     r2, [r0, #GPFPU_OFFSET]
	bic     r2, r2, #(3 << 12)
	orr     r1, r2, #(2 << 12)
	str     r1, [r0, #GPFPU_OFFSET]

	ldr     r2, [r0, #GPFDAT_OFFSET]	
	and     r2, r2, #(1 << 6)
	mov     r1, #(1 << 6)
	cmp     r2, r1 
	bne     30f

	/* YUP150 USB detect STATE */	
	ldr     r0, =ELFIN_GPIO_BASE
	ldr     r2, [r0, #GPGCON_OFFSET]
	bic     r1, r2, #(3 << 0)
	str     r1, [r0, #GPGCON_OFFSET]

	ldr     r2, [r0, #GPGPU_OFFSET]
	bic     r2, r2, #(3 << 0)
	orr     r1, r2, #(2 << 0)
	str     r1, [r0, #GPGPU_OFFSET]

	ldr     r2, [r0, #GPGDAT_OFFSET]
	ldr     r1, =(1 << 0)
	and     r2, r2, r1
	ldr     r1, =(1 << 0)
	cmp     r2, r1 
	beq     10f
	b	yup150_early_off

	/* YUP150 battery cheak */
30:     ldr     r0, =INFORM0_REG        /* INFORM0 register */
	ldr     r1, [r0]
	ldr     r2, =0x2BED
	cmp     r2, r1
	beq	25f			/* no delay when wakeup */

        /* ADC delay time for cold boot */
	ldr	r0, =0x3ffffff	
20:     add	r1, r1, #1
	cmp	r1, r0
	bne	20b	

25:     ldr	r4, =0
	ldr	r5, =0

	/* ADC clk enable */
	ldr     r0, =ELFIN_CLOCK_POWER_BASE
	ldr     r2, [r0, #PCLKCON_OFFSET]
	orr     r1, r2,  #(1 << 7)
	str     r1, [r0, #PCLKCON_OFFSET]

	ldr     r0, =ELFIN_ADC_BASE
	ldr	r1, =0xffff
	str     r1, [r0, #ADCDLY_OFFSET]

	/* ADC channel select ->0ch */
	ldr     r0, =ELFIN_ADC_BASE
	/*ldr     r2, [r0, #ADCMUX_OFFSET]*/
	ldr	r1, =0
	str     r1, [r0, #ADCMUX_OFFSET]
	
	ldr     r0, =ELFIN_ADC_BASE
	ldr	r2, =0
	orr     r2, r2,  #(1 << 14)
	orr     r1, r2,  #(21 << 6)
	str     r1, [r0, #ADCCON_OFFSET]

	 /* ADC con init */
	ldr     r0, =ELFIN_ADC_BASE
	ldr     r2, [r0, #ADCCON_OFFSET]
	bic     r2, r2, #0x7
	orr     r1, r2, #(1 << 3)
	str     r1, [r0, #ADCCON_OFFSET]

	/* ADC convert Enable */
1:	ldr     r0, =ELFIN_ADC_BASE
	ldr     r2, [r0, #ADCCON_OFFSET]
	orr     r1, r2, #(1 << 0)
	str     r1, [r0, #ADCCON_OFFSET]
#if 0
	/* ADC Conversion read start */
	ldr     r0, =ELFIN_ADC_BASE
	ldr     r2, [r0, #ADCCON_OFFSET]
	orr     r1, r2, #(1 << 1)
	str     r1, [r0, #ADCCON_OFFSET]
#endif
	ldr     r0, =ELFIN_ADC_BASE
2:      ldr     r2, [r0, #ADCCON_OFFSET]
	ldr     r1, =(1 << 15)
	and     r2, r2, r1
	ldr     r1, =(1 << 15)
	cmp     r2, r1 
	bne     2b

	ldr     r0, =ELFIN_ADC_BASE
	ldr     r2, [r0, #ADCDAT0_OFFSET]
	ldr     r3, =0xfff
	and     r2, r2, r3
	add	r4, r4, r2
	add	r5, r5, #1	
	ldr	r1, =100
	cmp	r5, r1	
	bne	1b

	/* yup150 battery minmum voltage setting 3.5v*/
	ldr     r3, =217000
	cmp     r4, r3 
	bhi     10f
	b	yup150_early_off

10:     mov     pc, lr


yup150_early_off:
        ldr     r0, =INFORM0_REG        /* INFORM0 register */
	ldr     r1, [r0]
	ldr     r2, =0x2BED
	cmp     r2, r1

	/* sleep if prev is sleep */
100:	ldreq   r0, =ELFIN_CLOCK_POWER_BASE
	ldreq   r1, =0x2bed
	streq   r1, [r0, #PWRMODECON_OFFSET]
	beq	100b

	/* power off */
200:    ldr	r0, =ELFIN_GPIO_BASE	
	ldr     r2, [r0, #GPADAT_OFFSET]
        bic     r2, r2, #(1 << 13)
	str     r2, [r0, #GPADAT_OFFSET]
	b       200b
